[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg)](http://makeapullrequest.com)
[![Build Status](https://ci.inria.fr/simgrid/buildStatus/icon?job=SimGrid)](https://ci.inria.fr/simgrid/job/SimGrid/)
[![AppVeyor Status](https://ci.appveyor.com/api/projects/status/gvcssh340fwtoc35?svg=true)](https://ci.appveyor.com/project/mquinson/simgrid)
[![SonarCloud Status](https://sonarcloud.io/api/project_badges/measure?project=simgrid_simgrid&metric=alert_status)](https://sonarcloud.io/dashboard/?id=simgrid_simgrid)
[![Doc](https://readthedocs.org/projects/pip/badge/?version=stable)](https://simgrid.org/doc/latest/)
[![License: LGPL v2.1][license-badge]](COPYING)
[![CII Best Practices](https://bestpractices.coreinfrastructure.org/projects/1845/badge)](https://bestpractices.coreinfrastructure.org/projects/1845)

# Welcome to the SimGrid project!

SimGrid is a scientific instrument to study the behavior of 
large-scale distributed systems such as Grids, Clouds, HPC or P2P
systems. It can be used to evaluate heuristics, prototype applications 
or even assess legacy MPI applications.

## Installation
Documentation: [online](https://simgrid.org/doc/latest/Installing_SimGrid.html#installing-from-the-source);
[local copy](docs/source/Installing_SimGrid.rst). TL;DR:
```
cmake -DCMAKE_INSTALL_PREFIX=/opt/simgrid .
# Check the full list of options with `cmake -LH`
make
make install
```

## More information
[Online documentation](https://simgrid.org/doc/latest/) or 
[local version](docs/source).

You can also ask your questions, or simply discuss with other users on 
to the [SimGrid mattermost](https://framateam.org/simgrid/channels/town-square)
or on the #simgrid IRC channel of the oftc network.

Last, the main development of SimGrid is done on [Framagit](https://framagit.org/simgrid/simgrid/),
but we also maintain a [GitHub mirror](https://github.com/simgrid/simgrid/) and an [Inria GitLab mirror](https://gitlab.inria.fr/simgrid/simgrid), 

Thanks for using our software. Please do great things with it and tell
the world about it. Tell us, too, because we love to have positive
feedback. Welcome to our community.

Cheers,
Da SimGrid Team.

[license-badge]: https://img.shields.io/badge/License-LGPL%20v2.1-blue.svg
[release-badge]: https://img.shields.io/github/release/simgrid/simgrid.svg
[release-link]:  https://gforge.inria.fr/frs/?group_id=12
